# Host

Host (bare metal or VM) requests

## GET /v3/host

> Get all your hosts (can be bare metal servers or VMs) and their main details

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model name","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true},"speed":{"type":"integer","format":"integer","description":"The speed this memory module runs at","readOnly":true},"ecc":{"type":"integer","format":"integer","description":"Set to 1 if ecc is supported and enabled","readOnly":true},"memoryBank":{"type":"integer","format":"integer","description":"The bank this module sits in","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory module","readOnly":true},"memorySlot":{"type":"string","format":"","description":"The slot this module sits in","readOnly":true},"memorySerial":{"type":"string","format":"","description":"The serial number of this module","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"HostUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host":{"get":{"tags":["Host"],"summary":"Get all your hosts (can be bare metal servers or VMs) and their main details","operationId":"getHosts","parameters":[{"name":"labels","in":"query","description":"Label expressions can be used to apply more specific search parameters and can be written in standard SQL query language.<br />\nE.g. `region_id=123` or multiple filters: `region_id=123 and fleet_id=456 or host_id=46256` The provided filter query needs to be url encoded. E.g.<br />\n`region_id%3D123` or multiple filters: `region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256` The total would look like:<br />\n`/host?labels=region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256`<br />\nIf you want to filter on a non-numeric label such as `region_name`, you have to wrap the value in double quotes: `region_name=\"Rotterdam\"`<br />\nWarning: the `labels` query parameter is ignored when passing a `PAGE-TOKEN` and the original `labels` string will be used for that request instead.<br />\nFor more information about labels check <a href=\"https://www.i3d.net/docs/one/odp/Platform-Elements/Application/Label/#pre-defined-labels\">details</a>","schema":{"type":"string"}},{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Host"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/summary

> Get all your hosts (can be bare metal servers or VMs) and their main details

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"HostSummary":{"type":"object","required":["id","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","brand","model","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/summary":{"get":{"tags":["Host"],"summary":"Get all your hosts (can be bare metal servers or VMs) and their main details","operationId":"getHostSummaries","parameters":[{"name":"fields","in":"query","description":"Fields return in response, only fields available in model can be filter out","schema":{"type":"string"}},{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/HostSummary"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/{hostId}

> Get a host (can be bare metal servers or VMs) and their main details

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model name","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true},"speed":{"type":"integer","format":"integer","description":"The speed this memory module runs at","readOnly":true},"ecc":{"type":"integer","format":"integer","description":"Set to 1 if ecc is supported and enabled","readOnly":true},"memoryBank":{"type":"integer","format":"integer","description":"The bank this module sits in","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory module","readOnly":true},"memorySlot":{"type":"string","format":"","description":"The slot this module sits in","readOnly":true},"memorySerial":{"type":"string","format":"","description":"The serial number of this module","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"HostUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/{hostId}":{"get":{"tags":["Host"],"summary":"Get a host (can be bare metal servers or VMs) and their main details","operationId":"getHost","parameters":[{"name":"hostId","in":"path","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Host"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/host/{hostId}

> Can add, edit or delete host labels. To delete label need to provide key with null value.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model name","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true},"speed":{"type":"integer","format":"integer","description":"The speed this memory module runs at","readOnly":true},"ecc":{"type":"integer","format":"integer","description":"Set to 1 if ecc is supported and enabled","readOnly":true},"memoryBank":{"type":"integer","format":"integer","description":"The bank this module sits in","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory module","readOnly":true},"memorySlot":{"type":"string","format":"","description":"The slot this module sits in","readOnly":true},"memorySerial":{"type":"string","format":"","description":"The serial number of this module","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"HostUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/{hostId}":{"put":{"tags":["Host"],"summary":"Can add, edit or delete host labels. To delete label need to provide key with null value.","operationId":"updateHost","parameters":[{"name":"hostId","in":"path","required":true,"schema":{"type":"integer"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Host"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Host"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Not Found"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/{hostId}/task

> Get the last 50 tasks of the given host

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"TaskStatus":{"type":"object","required":["id","name","batchId","categoryId","entityId","currentActionIdx","executeAt","lastActivityAt","finishedAt","resultCode","resultText"],"properties":{"id":{"type":"integer","format":"integer","description":"Task ID","readOnly":true},"name":{"type":"string","format":"","description":"Task name","readOnly":true},"batchId":{"type":"integer","format":"integer","description":"The ID of the batch the task belongs to","readOnly":true},"categoryId":{"type":"integer","format":"integer","description":"The ID of the task category. Valid values are:\n- 1: game server","readOnly":true},"entityId":{"type":"integer","format":"integer","description":"The ID of the entity the task is being executed for. E.g. a game server ID (categoryId 1)","readOnly":true},"currentActionIdx":{"type":"integer","format":"integer","description":"Currently active action index - relates to the action index as found in the template.","readOnly":true},"executeAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating the start of execution.","readOnly":true},"lastActivityAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating lastest activity.","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp at which the task was finished.","readOnly":true},"resultCode":{"type":"integer","format":"integer","description":"The result of the task. 0: pending, 1: in progress, 2: paused, 125: cancelled, 126: done with error, 127: done","readOnly":true},"resultText":{"type":"string","format":"","description":"The result of the task in message form.","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/{hostId}/task":{"get":{"tags":["Host"],"summary":"Get the last 50 tasks of the given host","operationId":"getHostTasks","parameters":[{"name":"hostId","in":"path","description":"The ID of the host","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/TaskStatus"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid hostId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/liveState

> Get live situation of all the gaming hosts

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"HostLiveState":{"type":"object","required":["id","serverId","cpuLoad","memMax","memUsed","memFree"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/liveState":{"get":{"tags":["Host"],"summary":"Get live situation of all the gaming hosts","operationId":"getHostLiveStates","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/HostLiveState"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/instanceType

> Get all bare metal instance types (and their details) available for your account

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"InstanceTypeBM":{"type":"object","required":["id","instanceType","cpuType","cpuSpeed","numCpu","numCoresPerCpu","memoryType","memorySpeed","memorySize"],"properties":{"id":{"type":"string","format":"","description":"The ID of the instance type","readOnly":true},"instanceType":{"type":"string","format":"","description":"The name of the instance type","readOnly":true},"cpuType":{"type":"string","format":"","description":"The type of CPU of the instance type","readOnly":true},"cpuSpeed":{"type":"integer","format":"integer","description":"The speed of CPU of the instance type","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"The number of CPUs of the instance type","readOnly":true},"numCoresPerCpu":{"type":"integer","format":"integer","description":"The number of cores per CPUs of the instance type","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory of the instance type","readOnly":true},"memorySpeed":{"type":"integer","format":"integer","description":"The memory speed of the instance type","readOnly":true},"memorySize":{"type":"integer","format":"integer","description":"The amount of memory of the instance type in MB","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/instanceType":{"get":{"tags":["Host"],"summary":"Get all bare metal instance types (and their details) available for your account","operationId":"getHostInstanceTypes","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceTypeBM"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/host/{hostId}/invoice

> Get all the invoices for a specific host

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Invoice":{"type":"object","required":["id","creationDate","dueDate","invoiceNumber","invoiceHash","description","currency","currencySign","amountIncVAT","amountExclVAT","paymentStatus","paymentDate","isCredit","remainingAmount","totalPaidAmount"],"properties":{"id":{"type":"string","format":"","description":"The ID of the invoice","readOnly":true},"creationDate":{"type":"integer","format":"integer","description":"The date the invoice was created","readOnly":true},"dueDate":{"type":"integer","format":"integer","description":"The due date of the invoice","readOnly":true},"invoiceNumber":{"type":"string","format":"","description":"The number of the invoice","readOnly":true},"invoiceHash":{"type":"string","format":"","description":"A unique hash for this invoice","readOnly":true},"description":{"type":"string","format":"","description":"The description of the invoice"},"currency":{"type":"string","format":"","description":"The currency that is being used"},"currencySign":{"type":"string","format":"","description":"The currency sign that is being used"},"amountIncVAT":{"type":"string","format":"","description":"The amount of the invoice with VAT in cents"},"amountExclVAT":{"type":"string","format":"","description":"The amount of the invoice without VAT in cents"},"paymentStatus":{"type":"integer","format":"integer","description":"The payment status"},"paymentDate":{"type":"integer","format":"integer","description":"The timestamp that the invoice was paid, if paid"},"isCredit":{"type":"integer","format":"integer","description":"If this field is 1 it means that invoice is a credit invoice"},"remainingAmount":{"type":"string","format":"","description":"The remaining amount of invoice"},"totalPaidAmount":{"type":"string","format":"","description":"The total paid amount of invoice"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/{hostId}/invoice":{"get":{"tags":["Host"],"summary":"Get all the invoices for a specific host","operationId":"getHostInvoices","parameters":[{"name":"hostId","in":"path","description":"ID of the host to fetch invoices for","required":true,"schema":{"type":"integer"}},{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Invoice"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid host ID"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/host/{hostId}/cancel

> Cancels a host. If you cancel a host you will continue to have access to the host until the end of the contract

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model name","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true},"speed":{"type":"integer","format":"integer","description":"The speed this memory module runs at","readOnly":true},"ecc":{"type":"integer","format":"integer","description":"Set to 1 if ecc is supported and enabled","readOnly":true},"memoryBank":{"type":"integer","format":"integer","description":"The bank this module sits in","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory module","readOnly":true},"memorySlot":{"type":"string","format":"","description":"The slot this module sits in","readOnly":true},"memorySerial":{"type":"string","format":"","description":"The serial number of this module","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"HostUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/host/{hostId}/cancel":{"put":{"tags":["Host"],"summary":"Cancels a host. If you cancel a host you will continue to have access to the host until the end of the contract","operationId":"cancelHost","parameters":[{"name":"hostId","in":"path","description":"ID of the host to cancel","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"cancelled successfully","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Host"}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid host ID"},"422":{"description":"Unable to cancel host"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/host/{hostId}/cancel/revert

> Reverts the cancellation of a host. You cannot revert the cancellation a host if the current date is equal to or past the end of contract date,\
> nor if the host was never cancelled

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Host","description":"Host (bare metal or VM) requests"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},
[...]
